!= Module HeatFlux
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: heatflux.f90,v 1.7 2012-04-03 19:00:46 yamasita Exp $
! Tag Name::  $Name: arare4-20120911 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview
!
! ή׻. 
!
! Υեåˤ벹٤ȶŷʬѲΨХ륯ˡ
! ŤƷ׻⥸塼
!
! Ǯեå Fh ȶŷʪΥեå Fq Ȥ, ٤ȶŷʪ
! ѲΨ H, Q 
!
!   H = Fh/z_1  
!   Q = Fq/z_1  
!
! ɽ.  z_1 ϺǲؤγʻҴֳ֤Ǥ.  
!
! Ǯեå Fh ȶŷʪΥեå Fq ϰʲμˤä
! ׻.
!
!   Fh = - Cd|V| * _1_1 
!   Fh = - Cd|V| * Q_1 
!
!  _1, Q_1, _1 Ϻǲؤβ٤ȶŷʪκ椪̵
! ϴؿ, T_sfc ϲβ, Q*(T_sfc)  T_sfc Ƿޤ˰º
! Ǥ. 
!
! Ǥϥǥǲؤβ٤᤹褦˥եåͿ. 
!
! ® v ȥХ륯 Cd ϰȤ. ̵ϴؿ _1 ϴܾ
! ͤѤ.
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!

module HeatFlux
  !
  !ǤΥեåη׻⥸塼
  !
  
  !⥸塼ɤ߹
  use gridset,  only: DimXMin,         & !x β
    &                 DimXMax,         & !x ξ
    &                 DimZMin,         & !z β
    &                 DimZMax,         & !z ξ
    &                 RegZMin,         & !z ʪΰβ
    &                 SpcNum,          & !
    &                 DelZ               !z γʻֳ
  use basicset, only: xz_ExnerBasicZ     !ʡؿδܾ
  use StorePotTemp,  only: StorePotTempFlux
  use StoreMixRt,    only: StoreMixRtFlux

  !ۤηػ
  implicit none

  !°λ
  private

  !ؿ public 
  public xz_HeatFluxBulk
  public xz_MixRtFluxBulk
  public xz_HeatFluxDiff
  public xz_MixRtFluxDiff
  public xza_MixRtFluxDiff

  !ѿ
  real(8)  :: Bulk = 1.5d-3        !Ǯư̥եåΥХ륯
  real(8)  :: Kappa = 800.0d0

  !ͤ¸
  save Bulk
  save Kappa

contains


!!!------------------------------------------------------------------------!!!
  function xz_HeatFluxBulk( xz_PotTemp )
    !
    ! Υեåˤ벹٤ѲΨХ륯ˡ
    ! ŤƷ׻.  
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)   :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !̤ξʬ    
    real(8)               :: xz_HeatFluxBulk(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ɽǮեå
    real(8)  :: VelX = 100.0d0             !ؤǤοʿ®٤ᤦ

    !
    !  * Ƥͤ򥼥˸
    xz_HeatFluxBulk = 0.0d0
    
    !ɽǮեå׻
    !  * ñ̤ K/s
    !  * ʻ xz Ǥ, ʪΰκǲüź RegZMin+1
    !
    xz_HeatFluxBulk(:,RegZMin+1) =                        &
      & max(                                              &
      &         0.0d0,                                    &
      &       - Bulk * VelX * xz_ExnerBasicZ(:,RegZMin+1) &
      &          * xz_PotTemp(:,RegZMin+1) / DelZ         &
      &    )
    
  end function xz_HeatFluxBulk
  
!!!------------------------------------------------------------------------!!!
  function xz_MixRtFluxBulk( xz_MixRt )
    !
    ! ΥեåˤŷʬѲΨХ륯ˡ
    ! ŤƷ׻.  
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)   :: xz_MixRt(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !̤ξʬ    
    real(8)               :: xz_MixRtFluxBulk(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ɽǮեå
    real(8)  :: VelX = 100.0d0             !ؤǤοʿ®٤ᤦ

    !
    !  * Ƥͤ򥼥˸
    xz_MixRtFluxBulk = 0.0d0

    
    xz_MixRtFluxBulk(:,RegZMin+1) =                        &
      & max(                                               &         
      &         0.0d0,                                     &
      &       - Bulk * VelX * xz_MixRt(:,RegZMin+1) / DelZ &
      &    )
    
  end function xz_MixRtFluxBulk


!!!------------------------------------------------------------------------!!!
  function xz_HeatFluxDiff( xz_PotTemp )

    implicit none

    real(8), intent(in)   :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)
    real(8)               :: xz_HeatFluxDiff(DimXMin:DimXMax,DimZMin:DimZMax)

    xz_HeatFluxDiff = 0.0d0

    xz_HeatFluxDiff(:,RegZMin+1) =                                        &
      &  - Kappa * xz_PotTemp(:,RegZMin+1) * xz_ExnerBasicZ(:, RegZMin+1) &
      &    / ( ( DelZ * 5.0d-1 ) ** 2.0d0 )

    call StorePotTempFlux( xz_HeatFluxDiff )

  end function xz_HeatFluxDiff


!!!------------------------------------------------------------------------!!!
  function xz_MixRtFluxDiff( xz_MixRt )

    implicit none

    real(8), intent(in)   :: xz_MixRt(DimXMin:DimXMax,DimZMin:DimZMax)
    real(8)               :: xz_MixRtFluxDiff(DimXMin:DimXMax,DimZMin:DimZMax)


    xz_MixRtFluxDiff = 0.0d0

    xz_MixRtFluxDiff(:,RegZMin+1) =                 &
      & max(                                        &
      &       0.0d0,                                &
      &     - Kappa * xz_MixRt(:,RegZMin+1)         &
      &        / ( ( DelZ * 5.0d-1 ) ** 2.0d0 )     &
      &    )

!    xz_MixRtFluxDiff(:,RegZMin+1) =               &
!      &  - Kappa * xz_MixRt(:,RegZMin+1)          &
!      &    / ( ( DelZ * 5.0d-1 ) ** 2.0d0 )       

  end function xz_MixRtFluxDiff


!!!------------------------------------------------------------------------!!!
  function xza_MixRtFluxDiff( xza_MixRt )

    implicit none

    real(8), intent(in)   :: xza_MixRt(DimXMin:DimXMax,DimZMin:DimZMax,SpcNum)
    real(8)               :: xza_MixRtFluxDiff(DimXMin:DimXMax,DimZMin:DimZMax,SpcNum)

    xza_MixRtFluxDiff = 0.0d0

    xza_MixRtFluxDiff(:,RegZMin+1,:) =         &
      &  - Kappa * xza_MixRt(:,RegZMin+1,:)    &
      &    / ( ( DelZ * 5.0d-1 ) ** 2.0d0 )       

!    xza_MixRtFluxDiff(:,RegZMin+1,:) =                 &
!      & max(                                           &
!      &      0.0d0,                                    &
!      &    - Kappa * xza_MixRt(:,RegZMin+1,:)          &
!      &      / ( ( DelZ * 5.0d-1 ) ** 2.0d0 )          &
!      &  )

    call StoreMixRtFlux( xza_MixRtFluxDiff )

  end function xza_MixRtFluxDiff


end module HeatFlux



!= Module HeatFlux_N1994
!
! Authors::   ODAKA Masatsugu 
! Version::   $Id: heatflux.f90,v 1.7 2012-04-03 19:00:46 yamasita Exp $
! Tag Name::  $Name: arare4-20120911 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview
!
! Υեåˤ벹٤ȶŷʬѲΨХ륯ˡ
! ŤƷ׻⥸塼.  (1994) Ѥ줿ˡǤ.
!
! Ǯեå Fh ȶŷʪΥեå Fq Ȥ, ٤ȶŷʪ
! ѲΨ H, Q 
!
!   H = Fh/z_1  
!   Q = Fq/z_1  
!
! ɽ.  z_1 ϺǲؤγʻҴֳ֤Ǥ.  
!
! Ǯեå Fh ȶŷʪΥեå Fq ϰʲμˤä
! ׻.
!
!   Fh = - Cd|V| * (_1_1 - T_sfc)
!   Fh = - Cd|V| * (Q_1 - Q*(T_sfc))
!
!  _1, Q_1, _1 Ϻǲؤβ٤ȶŷʪκ椪̵
! ϴؿ, T_sfc ϲβ, Q*(T_sfc)  T_sfc Ƿޤ˰º
! Ǥ. 
!
! Х륯 Cd ϰȤ. ̵ϴؿ _1 ϴܾͤѤ.
! ® |V| 
!
!   V = ( V^2 + V_0^2 )^(1/2)
!
! ȷ׻. 
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!
!== Future Plans
!
!

module HeatFlux_N1994
  !
  !ǤΥեåη׻⥸塼
  !
  
  !⥸塼ɤ߹
  use gridset,  only: DimXMin,         & !x β
    &                 DimXMax,         & !x ξ
    &                 DimZMin,         & !z β
    &                 DimZMax,         & !z ξ
    &                 RegZMin,         & !z ʪΰβ
    &                 DelZ               !z γʻֳ
  use basicset, only: xz_ExnerBasicZ  ,& !ʡؿδܾ
    &                 xz_PotTempBasicZ,& !̤δܾ
    &                 TempSfc         ,& !ɽ̲(ºݤϺǲؤβ)
    &                 PressSfc        ,& !ɽ̰ [Pa]
    &                 CpDry           ,& !ʬ갵Ǯ [J/K kg]
    &                 GasRDry         ,& !ʬε [J/K kg]
    &                 TempGnd            !ɽ̲(ɽ̥եå׻)

  use average, only:  xz_avr_pz
  use chemcalc, only: SvapPress

  !ۤηػ
  implicit none

  !°λ
  private

  !ؿ public 
  public xz_HeatFluxBulk
  public xz_MixRtFluxBulk

  !ѿ
  real(8)  :: Bulk = 1.5d-3        !Ǯư̥եåΥХ륯

  !ͤ¸
  save Bulk

contains


!!!------------------------------------------------------------------------!!!
  function xz_HeatFluxBulk( xz_PotTemp, pz_VelX )
    ! 
    ! Υեåˤ벹٤ѲΨ,
    ! Х륯ˡ˴ŤƷ׻.
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)   :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !̤ξʬ    
    real(8), intent(in)   :: pz_VelX(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ʿ®
    real(8)               :: xz_HeatFluxBulk(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ɽǮեå
    real(8)               :: VelX = 3.0d0  !ؤǤοʿ®ٿ夲
    integer               :: kz            !ź

    real(8), allocatable  :: xz_VelX(:,:)  !ʿ® (xz ʻ)


    !γդ
    allocate(xz_VelX(DimXMin:DimXMax,DimZMin:DimZMax))


    !
    !  * Ƥͤ򥼥˸
    xz_HeatFluxBulk = 0.0d0
    
    !ɽǮեåˤǮΨ׻
    !  * ñ̤ K/s
    !  * ʡؿϴܾͤɽ.     
    !  * ʻ xz Ǥ, ʪΰκǲüź RegZMin+1

    kz = RegZMin+1
    xz_VelX = xz_avr_pz(pz_VelX)

    xz_HeatFluxBulk(:,kz) =                                       &
      & MAX(                                                      &
      &       0.0d0,                                              & 
      &     - Bulk                                                &
      &       * SQRT(xz_VelX(:,kz)**2.0 + VelX**2.0)              &
      &       * (xz_ExnerBasicZ(:,kz)                             &
      &            * (xz_PotTemp(:,kz)  + xz_PotTempBasicZ(:,kz)) &
      &          - TempSfc                                        &
      &         )/DelZ                                            &
      &    )

    !β
    deallocate(xz_VelX)
    
  end function xz_HeatFluxBulk
  
!!!------------------------------------------------------------------------!!!
  function xz_MixRtFluxBulk( xz_MixRt, pz_VelX, xz_Exner, ID )
    !
    ! ΥեåˤŷʬѲΨ,
    ! Х륯ˡ˴ŤƷ׻.
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)   :: xz_MixRt(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !̤ξʬ    
    real(8), intent(in)   :: pz_VelX(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ʿ®
    real(8), intent(in)   :: xz_Exner(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !Ϥξʬ    
    integer, intent(in)   :: ID            !ŷʬ ID ֹ
    real(8)               :: xz_MixRtFluxBulk(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ɽ̺եå
    real(8)               :: VelX = 3.0d0  !ؤǤοʿ®ٿ夲
    integer               :: kz            !ź

    real(8), allocatable  :: xz_VelX(:,:)  !ʿ® (xz ʻ)


    !γդ
    allocate(xz_VelX(DimXMin:DimXMax,DimZMin:DimZMax))


    !
    !  * Ƥͤ򥼥˸
    xz_MixRtFluxBulk = 0.0d0

    kz = RegZMin+1
    xz_VelX = xz_avr_pz(pz_VelX)
    
    xz_MixRtFluxBulk(:,kz) =                                     &
      & max(                                                     &         
      &       0.0d0,                                             &
      &     - Bulk                                               &
      &       * SQRT(xz_VelX(:,kz)**2.0 + VelX**2.0)             &
      &       * (xz_MixRt(:,kz)                                  & 
      &            - SvapPress( ID, TempSfc ) / (                &
      &              ( xz_Exner(:,kz) + xz_ExnerBasicZ(:,kz) )   &
      &              **( CpDry / GasRDry )*PressSfc )            &
      &         )/DelZ                                           &
      &    )

    !β
    deallocate(xz_VelX)

    
  end function xz_MixRtFluxBulk
  
end module HeatFlux_N1994

!= Module HeatFlux_L1979
!
! Authors::   ODAKA Masatsugu 
! Version::   $Id: heatflux.f90,v 1.7 2012-04-03 19:00:46 yamasita Exp $
! Tag Name::  $Name: arare4-20120911 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview
!
! Υեåˤ벹٤ȶŷʬѲΨ Louis (1979)
! ŤƷ׻⥸塼. 
!
! Ǯեå Fh ȶŷʪΥեå Fq Ȥ, ٤ȶŷʪ
! ѲΨ H, Q 
!
!   H = Fh/z_1  
!   Q = Fq/z_1  
!
! ɽ.  z_1 ϺǲؤγʻҴֳ֤Ǥ.  
!
! Ǯեå Fh ȶŷʪΥեå Fq ϰʲμˤä
! ׻.
!
!   Fh = - Cd|V| * (_1_1 - T_sfc)
!   Fh = - Cd|V| * (Q_1 - Q*(T_sfc))
!
!  _1, Q_1, _1 Ϻǲؤβ٤ȶŷʪκ椪̵
! ϴؿ, T_sfc ϲβ, Q*(T_sfc)  T_sfc Ƿޤ˰º
! Ǥ. 
!
! Х륯 Cd ϥǥκǲؤγʻˤХ륯㡼ɥ
! δؿȤͿ. ̵ϴؿ _1 ϴܾͤѤ. 
! ® |V| 
!
!   V = ( V^2 + V_0^2 )^(1/2)
!
! ȷ׻. 
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!
!== Future Plans
!
!
module HeatFlux_L1979
    !
  !ǤΥեåη׻⥸塼
  !
  
  !⥸塼ɤ߹
  use gridset,  only: DimXMin,         & !x β
    &                 DimXMax,         & !x ξ
    &                 DimZMin,         & !z β
    &                 DimZMax,         & !z ξ
    &                 RegXMin,         & !x ʪΰ貼
    &                 RegXMax,         & !x ʪΰ
    &                 RegZMin,         & !z ʪΰβ
    &                 s_Z,             & !z ɸ(顼ʻ)
    &                 DelZ               !z γʻֳ
  use basicset, only: xz_ExnerBasicZ  ,& !ʡؿδܾ
    &                 xz_PotTempBasicZ,& !̤δܾ
    &                 TempSfc         ,& !ɽ̲(ºݤϺǲؤβ)
    &                 PressSfc        ,& !ɽ̰ [Pa]
    &                 PressBasis      ,& !̤δవ [Pa]
    &                 CpDry           ,& !ʬ갵Ǯ [J/K kg]
    &                 GasRDry         ,& !ʬε [J/K kg]
    &                 Grav               ! [m/s^2]

  use StorePotTemp,  only: StorePotTempFlux
  use average, only:  xz_avr_pz, pz_avr_xz
  use chemcalc, only: SvapPress

  !ۤηػ
  implicit none

  !°λ
  private

  !ؿ public 
  public xz_HeatFluxBulk
  public pz_MomFluxBulk

  !ѿ
  real(8) :: KARMAN = 0.35D0       ! lowest grid hight
  real(8) :: ROUGH  = 1.0D-2       ! surface roughness
  real(8) :: PARAM1 = 9.4D0        ! Louis parameter 1
  real(8) :: PARAM2 = 4.7D0        ! Louis parameter 2
  real(8) :: URMIN  = 1.0D-1       ! minimum wind velocity for Ri
  real(8) :: VelX = 0.0d0          !ؤǤοʿ®ٿ夲

  !ͤ¸
  save KARMAN, ROUGH, PARAM1, PARAM2, URMIN, VelX

contains

!!!------------------------------------------------------------------------!!!
  function xz_HeatFluxBulk( xz_PotTemp, xz_Exner, pz_VelX )
    ! 
    ! Υեåˤ벹٤ѲΨ, Louis (1979) 
    ! ˡ˴ŤƷ׻.
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)   :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)
                                           ! ̤ξʬ    
    real(8), intent(in)   :: xz_Exner(DimXMin:DimXMax,DimZMin:DimZMax)
                                           ! ʡؿξʬ    
    real(8), intent(in)   :: pz_VelX(DimXMin:DimXMax,DimZMin:DimZMax)
                                           ! ʿ®
    real(8)               :: xz_HeatFluxBulk(DimXMin:DimXMax,DimZMin:DimZMax)
                                           ! ɽǮեå
    real(8)               :: ExnerBZSfc    ! Basic state Exner function at the surface

    integer               :: kz            ! ź
    real(8), allocatable  :: xz_VelX(:,:)  ! ʿ® (xz ʻ)
    real(8), allocatable  :: x_RICHD(:)    ! Х륯㡼ɥ

    !γդ
    allocate(xz_VelX(DimXMin:DimXMax,DimZMin:DimZMax))
    allocate(x_RICHD(DImXMin:DimXMax))

    !
    !  * Ƥͤ򥼥˸
    xz_HeatFluxBulk = 0.0d0
    
    !ɽǮեåˤǮΨ׻
    !  * ñ̤ K/s
    !  * ʡؿϴܾͤɽ.     
    !  * ʻ xz Ǥ, ʪΰκǲüź RegZMin+1
    kz = RegZMin+1
    xz_VelX = xz_avr_pz(pz_VelX)

    ! Х륯㡼ɥη׻
    x_RICHD  = x_CLRICH(xz_PotTemp, xz_VelX)

    ! ɽ̤ǤΥʡؿܾʬ
    ExnerBZSfc    = (PressSfc / PressBasis) ** (GasRDry / CpDry)

    ! Ǯեåη׻
    xz_HeatFluxBulk(:,kz) =                                       &
      &     - x_CDRAGV(x_RICHD) * SQRT(xz_VelX(:,kz)**2.0 + VelX**2.0)  &
      &       * (                                                 &
      &            xz_PotTemp(:,kz)  + xz_PotTempBasicZ(:,kz)     &
      &          - TempSfc / ( ExnerBZSfc + xz_Exner(:,kz) )      &
      &         )/DelZ                                            

!    xz_HeatFluxBulk(:,kz) =                                       &
!      &     - x_CDRAGV(x_RICHD) * SQRT(xz_VelX(:,kz)**2.0 + VelX**2.0)  &
!      &       * (xz_ExnerBasicZ(:,kz)                             &
!      &            * (xz_PotTemp(:,kz)  + xz_PotTempBasicZ(:,kz)) &
!      &          - TempSfc                                        &
!      &         )/DelZ                                            

    call StorePotTempFlux( xz_HeatFluxBulk )

    !β
    deallocate(xz_VelX)
    deallocate(x_RICHD)
    
  end function xz_HeatFluxBulk
!!!------------------------------------------------------------------------!!!
  function pz_MomFluxBulk( xz_PotTemp, pz_VelX )
    ! 
    ! Υեåˤ뱿ư̤ѲΨ, Louis (1979) 
    ! ˡ˴ŤƷ׻.
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)   :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)
                                           ! ̤ξʬ    
    real(8), intent(in)   :: pz_VelX(DimXMin:DimXMax,DimZMin:DimZMax)
                                           ! ʿ®
    real(8)               :: xz_MomFluxBulk(DimXMin:DimXMax,DimZMin:DimZMax)
    real(8)               :: pz_MomFluxBulk(DimXMin:DimXMax,DimZMin:DimZMax)
                                           ! ɽǮեå
    integer               :: kz            ! ź
    real(8), allocatable  :: xz_VelX(:,:)  ! ʿ® (xz ʻ)
    real(8), allocatable  :: x_RICHD(:)    ! Х륯㡼ɥ

    !γդ
    allocate(xz_VelX(DimXMin:DimXMax,DimZMin:DimZMax))
    allocate(x_RICHD(DimXMin:DimXMax))

    !
    !  * Ƥͤ򥼥˸
    pz_MomFluxBulk = 0.0d0

    kz = RegZMin+1
    xz_VelX = xz_avr_pz(pz_VelX)

    ! Х륯㡼ɥη׻
    x_RICHD  = x_CLRICH(xz_PotTemp, xz_VelX)

    ! ư̥եåη׻
    xz_MomFluxBulk(:,kz) =                                       &
      &     - x_CDRAGV(x_RICHD) * SQRT(xz_VelX(:,kz)**2.0 + VelX**2.0)  &
      &     * xz_VelX(:,kz) / DelZ
    pz_MomFluxBulk = pz_avr_xz(xz_MomFluxBulk)

    !β
    deallocate(xz_VelX)
    deallocate(x_RICHD)

  end function pz_MomFluxBulk
!!!------------------------------------------------------------------------!!!
  function x_CDRAGV(x_RICHD)
    
    real(8), intent(in) :: x_RICHD(DimXMin:DimXMax)
    real(8)             :: x_CDRAGV(DimXMin:DimXMax)
    real(8)             :: PARAM3        ! Louis parameter 3
    real(8)             :: CDRAGN        ! Х륯(Ω)
    integer             :: kz

    ! ʻͤλ
    !  * ʻ xz Ǥ, ʪΰκǲüź RegZMin+1
    kz = RegZMin+1

    ! Х륯(Ω)η׻
    CDRAGN = ( KARMAN / ( LOG ( s_Z(kz) / ROUGH ) ) )**2

    ! Louis parameter 3
    PARAM3 = 7.4D0* CDRAGN * PARAM1 * SQRT( s_Z(kz) / ROUGH ) 

    where (x_RICHD > 0.0d0)

      x_CDRAGV = CDRAGN /( 1.0D0 + PARAM2 * x_RICHD )**2
            
    elsewhere

      x_CDRAGV = CDRAGN * ( 1.0D0 - (PARAM1 * x_RICHD )            &
        &          /( 1.0D0 + PARAM3 * SQRT( ABS( x_RICHD ) )))

    end where
   
  end function x_CDRAGV
!!!------------------------------------------------------------------------!!!
  function x_CLRICH(xz_PotTemp, xz_VelX)
  
    real(8), intent(in)  :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)
                                          ! ̤ξʬ    
    real(8), intent(in)  :: xz_VelX(DimXMin:DimXMax,DimZMin:DimZMax)
                                          ! ʿ®
    real(8)              :: x_CLRICH(DimXMin:DimXMax)
                                          ! Х륯㡼ɥ
    integer              :: ix, kz        ! ź
    real(8)              :: PotTempMean ! ǲؿʿʿѲ


    ! 
    x_CLRICH = 0.0d0

    kz = RegZMin+1

    ! ʿʿѲ̤η׻
    do ix = RegXMin, RegXMax
       PotTempMean = PotTempMean + xz_PotTemp(ix,kz) 
    end do

    PotTempMean = PotTempMean / real(RegXMax - RegXMin + 1) + &
   &              xz_PotTempBasicZ(1,kz)

    ! Х륯㡼ɥη׻

    x_CLRICH = Grav * s_Z(kz) *                            &
   &           (xz_PotTemp(:,kz)  + xz_PotTempBasicZ(:,kz) &
   &           - TempSfc)                                  &
   &           / PotTempMean / MAX( xz_VelX(:,kz)**2, URMIN**2 )

   end function x_CLRICH

end module HeatFlux_L1979
